/* Test program for the RNAdts package */



/* Include files */

#include "RNBasics/RNBasics.h"



/* Global variables */

static char *testdata[] = {
    "1", "2", "3", "4", 
    "5", "6", "7", "8", 
    "9", "10", "11", "12", 
    "13", "14", "15"
};

static const int ntestdata = (sizeof testdata)/sizeof(char *);



int main()
{
    /* Initialize library */
    if (!RNInitBasics()) exit(1); 

    /* Load array */
    RNArray<char *> array;
    for (int i = 0; i < ntestdata; i++) 
        array.Insert(testdata[i]); 

    /* Try a few more removes/inserts */
    assert(array.IsValid());
    array.RemoveKth(ntestdata/2);  
    array.RemoveEntry(array.PrevEntry(array.TailEntry()));  
    array.RemoveEntry(array.NextEntry(array.HeadEntry()));  
    array.RemoveHead(); 
    array.RemoveTail();  
    assert(array.IsValid());
    array.InsertHead(testdata[0]);  
    array.InsertTail(testdata[ntestdata-1]);  
    array.InsertBefore(testdata[ntestdata-2], array.TailEntry());  
    array.InsertAfter(testdata[1], array.HeadEntry()); 
    array.InsertKth(testdata[ntestdata/2], ntestdata/2);
    assert(array.IsValid());

    /* Print array entries */
    printf("Array Test ... \n");
    for (i = 0; i < array.NEntries(); i++) 
        printf("%s ", array.Kth(i)); 
    printf("\n");

    /* Stop library */
    RNStopBasics();

    /* Return success */
    return 0;
}



